// CustomToolView.h : interface of the CCustomToolView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_CUSTOMTOOLVIEW_H__C694B9DF_73CD_4AF8_AD65_FF39BFF06499__INCLUDED_)
#define AFX_CUSTOMTOOLVIEW_H__C694B9DF_73CD_4AF8_AD65_FF39BFF06499__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CCustomToolView : public CFODrawView
{
protected: // create from serialization only
	CCustomToolView();
	DECLARE_DYNCREATE(CCustomToolView)

// Attributes
public:
	CCustomToolDoc* GetDocument();
	
	// Generate pos string.
	virtual void GeneratePosString(CString &strText,int left,int top);
	
	// Generate size string.
	virtual void GenerateSizeString(CString &strText,int width,int height);

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CCustomToolView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	protected:
	virtual void OnInitialUpdate(); // called first time after construct
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);
	//Form++ Library add lines.
	virtual void OnPrint(CDC* pDC, CPrintInfo* pInfo);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CCustomToolView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CCustomToolView)
	afx_msg void OnDrawTool1();
	afx_msg void OnUpdateDrawTool1(CCmdUI* pCmdUI);
	afx_msg void OnDrawTool2();
	afx_msg void OnUpdateDrawTool2(CCmdUI* pCmdUI);
	afx_msg void OnDrawTool3();
	afx_msg void OnUpdateDrawTool3(CCmdUI* pCmdUI);
	afx_msg void OnDrawTool4();
	afx_msg void OnUpdateDrawTool4(CCmdUI* pCmdUI);
	afx_msg void OnDrawTool5();
	afx_msg void OnUpdateDrawTool5(CCmdUI* pCmdUI);
	afx_msg void OnDrawTool6();
	afx_msg void OnUpdateDrawTool6(CCmdUI* pCmdUI);
	afx_msg void OnDrawTool7();
	afx_msg void OnUpdateDrawTool7(CCmdUI* pCmdUI);
	afx_msg void OnDrawTool8();
	afx_msg void OnUpdateDrawTool8(CCmdUI* pCmdUI);
	afx_msg void OnDrawTool9();
	afx_msg void OnUpdateDrawTool9(CCmdUI* pCmdUI);
	afx_msg void OnDrawTool10();
	afx_msg void OnUpdateDrawTool10(CCmdUI* pCmdUI);
	//}}AFX_MSG
	afx_msg void OnUpdatePosition(CCmdUI *pCmdUI);
	afx_msg void OnUpdateWidth(CCmdUI *pCmdUI);
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in CustomToolView.cpp
inline CCustomToolDoc* CCustomToolView::GetDocument()
   { return (CCustomToolDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_CUSTOMTOOLVIEW_H__C694B9DF_73CD_4AF8_AD65_FF39BFF06499__INCLUDED_)
