// MainFrm.h : interface of the CMainFrame class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_MAINFRM_H__F38BAA60_CDAE_4ED0_9A3F_9154BFF8CF69__INCLUDED_)
#define AFX_MAINFRM_H__F38BAA60_CDAE_4ED0_9A3F_9154BFF8CF69__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "MyColorPaletteBar.h"

#include "MenuBar.h"

class CMainFrame : public CMDIFrameWnd
{
	DECLARE_DYNAMIC(CMainFrame)
public:
	CMainFrame();
	
	// Attributes
public:
	
	// Operations
public:
	CMyColorPaletteBar m_wndColorBar; //Form++ Library add line.
	//Form++ Library add lines.

	CFOMultiToolBoxBar m_FileBar;
	//Form++ Library add lines.

	void DockControlBarLeftOf(CToolBar* Bar,CToolBar* LeftOf);
	// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMainFrame)
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	//}}AFX_VIRTUAL
	
	// Implementation
public:
	virtual ~CMainFrame();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif
	
protected:  // control bar embedded members
	CStatusBar  m_wndStatusBar;
	CToolBar    m_wndToolBar;
	//Form++ Library add lines.
	CToolBar    m_wndDrawToolBar;
	//Form++ Library add lines.
	CToolBar    m_wndFormatToolBar;
	CToolBar    m_wndAllignToolBar;
	
	CMenuBar	m_wndMenuBar;
	
	// Generated message map functions
protected:
	//{{AFX_MSG(CMainFrame)
	afx_msg void OnViewPalettebar();
	afx_msg void OnUpdateViewPalettebar(CCmdUI* pCmdUI);
	afx_msg void OnViewDrawbar();
	afx_msg void OnUpdateViewDrawbar(CCmdUI* pCmdUI);
	afx_msg void OnViewFormatbar();
	afx_msg void OnUpdateViewFormatbar(CCmdUI* pCmdUI);
	afx_msg void OnViewToolbox();
	afx_msg void OnUpdateViewToolbox(CCmdUI* pCmdUI);
	afx_msg int OnCreate(LPCREATESTRUCT LPCREATESTRUCT);
	afx_msg void OnMailMe();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MAINFRM_H__F38BAA60_CDAE_4ED0_9A3F_9154BFF8CF69__INCLUDED_)
